<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Expression Examples</TITLE>
<link href="builder_17.html" rel=Next>
<link href="builder_15.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_15.html">previous</A>, <A HREF="builder_17.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC38" HREF="builder_toc.html#TOC38">Examples</A></H2>



<H3><A NAME="SEC39" HREF="builder_toc.html#TOC39">A Simple Example</A></H3>

<P>
Assume that a copmiler pass needs to create a statement that adds two
given variables.  Builder will perform this task in a simple and elegant
manner.

</P>

<PRE>
<A NAME="IDX108"></A>tree_node_list * b_gets_a_plus_b(tree_proc * proc,
                                 var_sym * a, 
                                 var_sym * b)
{
        block::set_proc(proc)

        block A(a);
        block B(b);
        block result(B = A + B);
        
        return result.make_tree_node_list()
}
</PRE>

<P>
The function <CODE>b_gets_a_plus_b()</CODE> takes the current SUIF
procedure and two variables and produce a <CODE>tree_node_list</CODE>
containing the resulting statement.

</P>
<P>
Before using any builder commands, the current procedure must be
set using <CODE>set_proc()</CODE>. Two <CODE>blocks</CODE> were created for the
variables and a result block was obtained by composing these two
<CODE>blocks</CODE>.  Overloaded <CODE>=</CODE> and <CODE>+</CODE> operators were used to
perform the composition. Finally, the <CODE>tree_node_list</CODE> was
generated for the result block.

</P>
<P>
There are many possible ways to calculate the <CODE>block</CODE> with the
correct statement. Following are a few possibilities.

</P>



<H3><A NAME="SEC40" HREF="builder_toc.html#TOC40">Example: In a Single Line</A></H3>
<P>
<A NAME="IDX109"></A>

<PRE>
        block result(block(b) = block(a) + block(b));
</PRE>

<P>
Since a complete set of operator overloading is given, any C++ syntax
and semantics  will work. 

</P>


<H3><A NAME="SEC41" HREF="builder_toc.html#TOC41">Example: A Single Composition at Each Step</A></H3>
<P>
<A NAME="IDX110"></A>

<PRE>
        block A(a);
        block B(b);
        block add2(A + B);
        block result(B = add2);
</PRE>



<H3><A NAME="SEC42" HREF="builder_toc.html#TOC42">Example: No Operator Overloading</A></H3>
<P>
<A NAME="IDX111"></A>
Instead of operator overloading, explicit composition functions can be
used to perform composition. Control flow and other constructs are
handled in this manner. 

</P>

<PRE>
        block A(a);
        block B(b);
        block add2(block::op(A, bop_add, B));
        block result(block::op(B, aop_eq, add2));
</PRE>



<H3><A NAME="SEC43" HREF="builder_toc.html#TOC43">Example: Using Operator Symbols</A></H3>
<P>
<A NAME="IDX112"></A>
When using explicit composition functions, instead of providing an
enumeration value specifying the operation (see section <A HREF="builder_34.html#SEC65">Operators</A>), an
ASCII string representing the operation can be used.

</P>

<PRE>
        block A(a);
        block B(b);
        block add2(block::op(A, "+", B));
        block result(block::op(B, "=", add2));
</PRE>



<H3><A NAME="SEC44" HREF="builder_toc.html#TOC44">Example: Yet Another Method</A></H3>
<P>
<A NAME="IDX113"></A>

<PRE>
        block A(a);
        block B(b);
        block add2(A.dobinop(bop_add, B));
        block result(B.doasignop(aop_eq, add2));
</PRE>

<P>
There are many different possibilities for creating expressions and
statements (see section <A HREF="builder_14.html#SEC33">Creating Expressions and Statements</A>).

</P>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_15.html">previous</A>, <A HREF="builder_17.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
